clear all
close all
clc

%%%%%%%%%%%%%%%%%%%%%%%%%%%%MODEL SPECIFIC BLOCK%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%CHOOSE THE MOD FILE NAME%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
model_string='NKlinear_indeter';%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%CHOOSE THE NAME OF THE TWO PARAMETERS FOR THE LOOP%%%%%%%%%%%%
parameter1_string=['\theta_\pi'];%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
parameter2_string=['\rho_r'];%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%CHOOSE THE GRID FOR EACH PARAMETER IN THE LOOP%%%%%%%%%%%%%%%%
parameter1_min=0;%starting value%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
parameter1_step=0.5;%step for the grid%%%%%%%%%%%%%%%%%%%%%%%%%%
parameter1_max=1;%maximum value%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
parameter2_min=0;%starting value%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
parameter2_step=0.1;%step for the grid%%%%%%%%%%%%%%%%%%%%%%%%%%
parameter2_max=1.0;%maximum value%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%END OF THE MODEL SPECIFIC BLOCK%%%%%%%%%%%%%%%%%%%%%%%%%%


%% DO NOT CHANGE THIS PART.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%DEFINE PARAMETERS GRIDS
parameter1=[parameter1_min:parameter1_step:parameter1_max];
parameter2=[parameter2_min:parameter2_step:parameter2_max];
for j=1:length(parameter1);
      for i=1:length(parameter2);
        %%%CALL DYNARE FOR EACH PARAMETER VALUE
          model=['dynare ' model_string ' noclearall'];

             
    eval(model)

%the following corrected for 4.3.3
qz_criterium = 1.000001;
%no of eigenvalue(s) larger than 1 in modulus - 4.3.3
n_explod = nnz(abs(oo_.dr.eigval) > qz_criterium);
%new definition for nfwrd for 4.3.3 - M_.endo_nbr-M_.nstatic-M_.npred
nfwrd = M_.endo_nbr-M_.nstatic-M_.npred;

    %if oo_.dr.nsfwrd==oo_.dr.rank     -- 4.2.1
    %if M_.nfwrd == n_explod    
    if nfwrd == n_explod     %%IF # OF NON-PREDETERMINED VARIABLES == RANK -->UNIQUE EQUILIBRIUM, SADDLE PATH STABLE
       ind(j,i)=0;
        
    %elseif oo_.dr.nsfwrd<oo_.dr.rank  -- 4.2.1
    %elseif M_.nfwrd < n_explod  
    elseif nfwrd < n_explod   %%IF # OF NON-PREDETERMINED VARIABLES  < RANK -->INSTABILITY  
       ind(j,i)=3;
        
    %elseif oo_.dr.nsfwrd>oo_.dr.rank  -- 4.2.1
    %elseif M_.nfwrd > n_explod  
    elseif nfwrd > n_explod   %%IF # OF NON-PREDETERMINED VARIABLES  > RANK -->INDETERMINACY
       ind(j,i)=4;
        
        pause(2)
    end
    
      end
end
   
save indet.mat  %SAVES THE RESULTS SO THERE IS NO NEED TO RUN THE LOOP AGAIN

%%PLOT THE REGIONS OF SADDLE PATH STABILITY, INDETERMINACY AND INSTABILITY
figure(1)
markersize=1;
spy(ind(:,:)==0,'r.');
hold on 
spy(ind(:,:)==4,'k.');
hold on 
spy(ind(:,:)==3,'g.');
axis xy;
set(gca,'XTick',1:1:length(parameter2));
set(gca,'XTicklabel',{parameter2_min:parameter2_step:parameter2_max});
set(gca,'YTick',1:1:length(parameter1));
set(gca,'YTicklabel',{parameter1_min:parameter1_step:parameter1_max});
title('Indeterminacy NK','fontsize',9); xlabel(parameter2_string,'fontsize',9);
ylabel(parameter1_string,'fontsize',9);    
%legend('Determinacy','Indeterminacy','Instability',-1);
legend('Determinacy','Indeterminacy','Instability');